if (typeof nrdp != 'undefined')
{
    console.log('nrdp already defined!');
    return;
}

function activationDataChanged( dataString )
{
    return [];
}

function activationData()
{
    return [];
}


nrdp = new Object();

nrdp.exit = function()
{
	n_device_api.exit();
};

nrdp.debug = new Object();

nrdp.debug.console = new Object();

nrdp.debug.console.log = function(message)
{
    console.log(message);
};

nrdp.debug.isDebug = function(message)
{
    return ##NRDP_DEBUG##;
};
	

nrdp.debug.console.warn = function(message)
{
    console.log('WARN: ' + message);
};

nrdp.debug.console.error = function(message)
{
    console.log('ERROR: ' + message);
};


nrdp.device = new Object();

nrdp.device.__defineGetter__("language", function() { return '##NRDP_LANGUAGE##'; } );
nrdp.device.__defineGetter__("apiUsesHtmlVideoElement", function() { return false; } );


nrdp.device.getModel = function()
{
	return String(n_device_api.getModel());
};

nrdp.device.getSoftwareVersion = function()
{
	return String(n_device_api.getSoftwareVersion());
};

nrdp.device.getCertificationVersion = function()
{
	return String(n_device_api.getCertificationVersion());
};

nrdp.device.getESN = function()
{
	return String(n_device_api.getESN());
};

nrdp.device.getESNPrefix = function()
{
	return String(n_device_api.getESNPrefix());
};

nrdp.device.setUIVersion = function(version)
{
	n_device_api.setUIVersion(version);
};

nrdp.device.isScreensaverOn = function()
{
	return (n_device_api.isScreensaverOn() == 'true');
};

nrdp.device.hasPointer = function()
{
    return (n_device_api.hasPointer() == 'true');
};

nrdp.device.deactivate = function()
{

};

nrdp.device.hasKeyboard = function()
{
    return (n_device_api.hasKeyboard() == 'true');
};

nrdp.device.hasOnScreenKeyboard = function()
{
    return (n_device_api.hasOnScreenKeyboard() == 'true');
};

nrdp.device.getLanguage = function()
{
	return String(n_device_api.getLanguage());
};

nrdp.device.launchUrl = function(url)
{
	n_device_api.launchUrl(url);
};

nrdp.device.notifyOnLogin = function()
{
	n_device_api.notifyOnLogin();
};

nrdp.device.notifyOnLogout = function()
{
	n_device_api.notifyOnLogout();
};

nrdp.device.notifyOnReady = function()
{
	n_device_api.notifyOnReady();
};

nrdp.device.injectKey = function(keyCode)
{
	n_device_api.injectKey(keyCode);
};

nrdp.device.isConnected = function()
{
    return (n_device_api.isConnected() == 'true');
};

nrdp.webapi = new Object();

nrdp.webapi.getConsumerKey = function()
{
	return n_web_api.getConsumerKey();
};

nrdp.webapi.getConsumerSecret = function()
{
	return String(n_web_api.getConsumerSecret());
};

nrdp.webapi.hmacSha1 = function(key, plaintext, handler)
{
        try
        {
            if (typeof(handler) !== 'undefined' && handler !== null)
            {
                var encValue = n_web_api.hmacSha1(key, plaintext);
                handler(encValue);
            }
        }
        catch (e)
        {
            console.log('ERROR: ' + e);
        }
};

nrdp.video = new Object();

nrdp.createVideo = function()
{
    return nrdp.video;
};

nrdp.appendVideo = function(video, parentElement)
{
};

nrdp.video.__defineGetter__("htmlVideoElement", function() { return null; } );

nrdp.video.__defineGetter__("MEDIA_ERR_ABORTED", function() { return 'MEDIA_ERR_ABORTED'; } );
nrdp.video.__defineGetter__("MEDIA_ERR_NETWORK", function() { return 'MEDIA_ERR_NETWORK'; } );
nrdp.video.__defineGetter__("MEDIA_ERR_DECODE", function() { return 'MEDIA_ERR_DECODE'; } );
nrdp.video.__defineGetter__("MEDIA_ERR_SRC_NOT_SUPPORTED", function() { return 'MEDIA_ERR_SRC_NOT_SUPPORTED'; } );

nrdp.video.__defineGetter__("NETWORK_EMPTY", function() { return 'NETWORK_EMPTY'; } );
nrdp.video.__defineGetter__("NETWORK_IDLE", function() { return 'NETWORK_IDLE'; } );
nrdp.video.__defineGetter__("NETWORK_LOADING", function() { return 'NETWORK_LOADING'; } );
nrdp.video.__defineGetter__("NETWORK_NO_SOURCE", function() { return 'NETWORK_NO_SOURCE'; } );

nrdp.video.__defineGetter__("HAVE_NOTHING", function() { return 'HAVE_NOTHING'; } );
nrdp.video.__defineGetter__("HAVE_METADATA", function() { return 'HAVE_METADATA'; } );
nrdp.video.__defineGetter__("HAVE_CURRENT_DATA", function() { return 'HAVE_CURRENT_DATA'; } );
nrdp.video.__defineGetter__("HAVE_FUTURE_DATA", function() { return 'HAVE_FUTURE_DATA'; } );
nrdp.video.__defineGetter__("HAVE_ENOUGH_DATA", function() { return 'HAVE_ENOUGH_DATA'; } );

nrdp.video.__defineGetter__("instantBitRate", function() { 
    var tmp = (+n_video_api.getInstantBitRate());
    if(tmp < 0) {
        return NaN;
     } else {
        return tmp;
     }    
});

nrdp.video.__defineGetter__("error", function() { 
    var tmp = String(n_video_api.getError());
    if (tmp == '') {
        return null;
    } else {
        return eval('(' + tmp + ')');
    }
});

nrdp.video.__defineGetter__("targetBitRate", function() { 
    var tmp = (+n_video_api.getTargetBitRate());
    if(tmp < 0) {
        return NaN;
     } else {
        return tmp;
     }    
});

nrdp.video.__defineGetter__("isHighDefinition", function() { return Boolean(n_video_api.isHighDefinition()); } );

nrdp.video.__defineGetter__("networkState", function() { return String(n_video_api.getNetworkState()); } );
nrdp.video.__defineGetter__("readyState", function() { return String(n_video_api.getReadyState()); } );

nrdp.video.__defineGetter__("seeking", function() { return Boolean(n_video_api.isSeeking()); } );

nrdp.video.__defineGetter__("currentTime", function() { 
    console.log('currentTime = ' + n_video_api.getCurrentTime());
    var tmp = (+n_video_api.getCurrentTime());
    if(tmp < 0) {
        console.log('currentTime NaN');
        return NaN;
     } else {
        console.log('currentTime value ' + tmp);
        return tmp;
     }
});

nrdp.video.__defineSetter__("currentTime", function(time) { 
    n_video_api.setCurrentTime(time) 
});

nrdp.video.__defineGetter__("duration", function() { 
    var tmp = (+n_video_api.getDuration());
    if(tmp < 0) {
        console.log('duration NaN');
        return NaN;
     } else {
        console.log('duration value ' + tmp);
        return tmp;
     }    
});

nrdp.video.__defineGetter__("paused", function() { return Boolean(n_video_api.isPaused()); } );
nrdp.video.__defineGetter__("ended", function() { return Boolean(n_video_api.isEnded()); } );
nrdp.video.__defineGetter__("autoplay", function() { return Boolean(n_video_api.isAutoplay()); } );
nrdp.video.__defineSetter__("autoplay", function(value) { 
    n_video_api.setAutoplay(value);
});

nrdp.video.__defineSetter__("src", function(value) { 
    n_video_api.setSource(value);
});

nrdp.video.__defineGetter__("src", function() { 
    return String(n_video_api.getSource());
});

nrdp.video.__defineGetter__("audioTrack", function() { return null; } );
nrdp.video.__defineSetter__("audioTrack", function(value) { });

nrdp.video.__defineGetter__("timedText", function() { return null; } );
nrdp.video.__defineSetter__("timedText", function(value) { });

nrdp.video.__defineGetter__("poster", function() { return ''; } );
nrdp.video.__defineSetter__("poster", function(value) { });

nrdp.video.__defineGetter__("top", function() { return 0; } );
nrdp.video.__defineSetter__("top", function(value) { });

nrdp.video.__defineGetter__("left", function() { return 0; } );
nrdp.video.__defineSetter__("left", function(value) { });

nrdp.video.__defineGetter__("width", function() { 
    var tmp = (+n_video_api.getWidth());
    if(tmp < 0) {
        console.log('width NaN');
        return NaN;
     } else {
        console.log('width ' + tmp);
        return tmp;
     }    
});

nrdp.video.__defineSetter__("width", function(value) { });

nrdp.video.__defineSetter__("height", function(value) { });

nrdp.video.__defineGetter__("height", function() { 
    var tmp = (+n_video_api.getHeight());
    if(tmp < 0) {
        console.log('height NaN');
        return NaN;
     } else {
        console.log('height ' + tmp);
        return tmp;
     }    
});

nrdp.video.__defineGetter__("videoWidth", function() { 
    var tmp = (+n_video_api.getVideoWidth());
    if(tmp < 0) {
        console.log('video width NaN');
        return NaN;
     } else {
        console.log('video width ' + tmp);
        return tmp;
     }    
});

nrdp.video.__defineGetter__("videoHeight", function() { 
    var tmp = (+n_video_api.getVideoHeight());
    if(tmp < 0) {
        console.log('video height NaN');
        return NaN;
     } else {
        console.log('video height ' + tmp);
        return tmp;
     }    
});

nrdp.video.__defineGetter__("currentSrc", function() { return nrdp.video.src; } );

nrdp.video.__defineGetter__("autobuffer", function() { return false; } );
nrdp.video.__defineSetter__("autobuffer", function(value) { });

nrdp.video.__defineGetter__("buffered", function() { return null; } );
nrdp.video.__defineGetter__("startTime", function() { return 0.0; } );

nrdp.video.__defineGetter__("defaultPlaybackRate", function() { return 1.0; } );
nrdp.video.__defineSetter__("defaultPlaybackRate", function(value) { });

nrdp.video.__defineGetter__("playbackRate", function() { return 1.0; } );
nrdp.video.__defineSetter__("playbackRate", function(value) { });

nrdp.video.__defineGetter__("played", function() { return null; } );

nrdp.video.__defineGetter__("loop", function() { return false; } );
nrdp.video.__defineSetter__("loop", function(value) { });

nrdp.video.__defineGetter__("controls", function() { return false; } );
nrdp.video.__defineSetter__("controls", function(value) { });

nrdp.video.__defineGetter__("volume", function() { return 0.0; } );
nrdp.video.__defineSetter__("volume", function(value) { });

nrdp.video.__defineGetter__("muted", function() { return false; } );
nrdp.video.__defineSetter__("muted", function(value) { });

nrdp.video.__defineGetter__("audioTrackList", function() { return []; } );
nrdp.video.__defineGetter__("timedTextTrackList", function() { return []; } );

nrdp.video.canPlayType = function(mimeType)
{
	return String(n_video.canPlayType(mimeType));
};

nrdp.video.__defineGetter__("seekable", function() { return null; } );

nrdp.video.play = function()
{
    n_video_api.play();
};

nrdp.video.pause = function()
{
    n_video_api.pause();
};

nrdp.video.stop = function()
{
	n_device_api.setBackResult('player');
};


nrdp.video.getLastPlayedMovieData = function()
{
    return eval('(' + String(n_video_api.getLastPlayedMovieData()) + ')');
};

nrdp.video.setGlobalEventListener = function(listener)
{
    var events = String(n_video_api.getEvents());
    var eventArray = events.split(" ");
    if(typeof(listener) != 'undefined' && listener != null)
    {
        for(i = 0; i < eventArray.length; i++){
            document.addEventListener(eventArray[i], listener, false);
        }
    } else {
        for(i = 0; i < eventArray.length; i++){
            document.removeEventListener(eventArray[i], nrdp.video._globalEventListener, false);
        }    
    }
    nrdp.video._globalEventListener = listener;
};


nrdp.video.addEventListener = function(type, listener, useCapture)
{
    document.addEventListener(type, listener, useCapture);
    n_video_api.registerEvent(type);
};

nrdp.video.removeEventListener = function(type, listener, useCapture)
{
    document.removeEventListener(type, listener, useCapture);
    n_video_api.unregisterEvent(type);
};

nrdp.video.dispatchEvent = function(evt)
{
    document.dispatchEvent(evt);
};

nrdp.video._dispatchEvent = function(evt_type, evt_name)
{
    var evt = document.createEvent(evt_type);
    evt.initEvent(evt_name, true, true);
    nrdp.video.dispatchEvent(evt);
};

nrdp.video._dispatchProgressEvent = function(evt_type, evt_name, loaded, total)
{
    var evt = document.createEvent(evt_type);
    evt.initEvent(evt_name, false, false);
    evt.loaded = loaded;
    evt.total = total;
    evt.lengthComputable = true;
    evt.loadedItems = 0;
    evt.totalItems = 0;
    nrdp.video.dispatchEvent(evt);
};

nrdp.video._dispatchLanguageChangeEvent = function(evt_type, evt_name, old_language, new_language)
{
    nrdp.device.language = new_language;
    var evt = document.createEvent(evt_type);
    evt.initEvent(evt_name, false, false);
    evt.old = old_language;
    nrdp.video.dispatchEvent(evt);
};

nrdp.video._dispatchNccpReasonCodeEvent = function(evt_type, evt_name, data)
{
    var evt = document.createEvent(evt_type);
    evt.initEvent(evt_name, true, true);
    evt.parameters = data;
    nrdp.video.dispatchEvent(evt);
};

nrdp.video.getLastPlayedMovieData = function()
{
    return eval('(' + String(n_video_api.getLastPlayedMovieData()) + ')');
};

